VERSION 5.00
Begin VB.Form frmDevice_Example 
   Caption         =   "ICS Non-controller Example"
   ClientHeight    =   7605
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   10155
   LinkTopic       =   "Form1"
   ScaleHeight     =   7605
   ScaleWidth      =   10155
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtError 
      Height          =   495
      Left            =   480
      TabIndex        =   12
      Text            =   "Text1"
      Top             =   6120
      Visible         =   0   'False
      Width           =   8055
   End
   Begin VB.TextBox txtRev 
      BackColor       =   &H80000004&
      BorderStyle     =   0  'None
      Height          =   375
      Left            =   5040
      TabIndex        =   11
      Top             =   6960
      Width           =   3375
   End
   Begin VB.Frame frmOutputMsg 
      Caption         =   "Response Message"
      Height          =   1815
      Left            =   960
      TabIndex        =   6
      Top             =   3960
      Width           =   8055
      Begin VB.CheckBox ckLF 
         Caption         =   "add LF"
         Height          =   255
         Left            =   4200
         TabIndex        =   14
         Top             =   480
         Width           =   1455
      End
      Begin VB.CheckBox ckCR 
         Caption         =   "add CR"
         Height          =   255
         Left            =   2760
         TabIndex        =   13
         Top             =   480
         Width           =   1215
      End
      Begin VB.CheckBox ckAutoSend 
         Caption         =   "Auto Reply"
         Height          =   255
         Left            =   840
         TabIndex        =   9
         Top             =   480
         Width           =   1455
      End
      Begin VB.CommandButton cmdSend 
         Caption         =   "Send"
         Height          =   495
         Left            =   6600
         TabIndex        =   8
         Top             =   240
         Width           =   1095
      End
      Begin VB.TextBox txtRespMsg 
         Height          =   615
         Left            =   360
         MultiLine       =   -1  'True
         TabIndex        =   7
         Top             =   960
         Width           =   7335
      End
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "Exit"
      Height          =   615
      Left            =   8760
      TabIndex        =   5
      Top             =   6120
      Width           =   1215
   End
   Begin VB.Frame frmInput 
      Caption         =   "Input Message"
      Height          =   1575
      Left            =   960
      TabIndex        =   3
      Top             =   1920
      Width           =   8055
      Begin VB.CommandButton cmdRead 
         Caption         =   "Read"
         Height          =   495
         Left            =   6600
         TabIndex        =   10
         Top             =   240
         Width           =   1095
      End
      Begin VB.TextBox txtInputMsg 
         Height          =   615
         Left            =   480
         MultiLine       =   -1  'True
         TabIndex        =   4
         Top             =   840
         Width           =   7215
      End
   End
   Begin VB.Frame frmSetAddr 
      Caption         =   "Device  Address"
      Height          =   1095
      Left            =   3120
      TabIndex        =   0
      Top             =   360
      Width           =   2415
      Begin VB.CommandButton cmdSet 
         Caption         =   "Set"
         Height          =   495
         Left            =   360
         TabIndex        =   2
         Top             =   480
         Width           =   855
      End
      Begin VB.TextBox txtAddr 
         Height          =   495
         Left            =   1440
         TabIndex        =   1
         Top             =   480
         Width           =   735
      End
   End
   Begin VB.Image ImageICS 
      Appearance      =   0  'Flat
      Height          =   765
      Left            =   7680
      Picture         =   "Dev_example.frx":0000
      Stretch         =   -1  'True
      Top             =   240
      Width           =   2340
   End
End
Attribute VB_Name = "frmDevice_Example"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'*********************************************************************************
'   Visual Basic GPIBkybd2 Program                                                      07-24-02
'   Copyright 2002 ICS Electronics div Systems West, Inc.
'
'   Program makes the GPIB board a device to receive and send strings
'   Program controls the GPIB-32.dll with NI type ib calls
'**********************************************************************************
Dim CmdStr As String
Dim OutFlag
Public NL
Public Msg_Format$
Public Cmd$
Public FirstTimeFlg
Public Curaddr%
Public Device                       'ppss address form
Public GPIB_BD%
Public Er%
Public vtmo                         'current Timeout Setting
Const winPictureBox = 2016002
Const winCommandButton = 2007557
Dim Outbuf As String * 1000
Dim Inbuf As String * 1000
Dim GPIB_Intfc As String

Private Sub cmdExit_Click()
    Call ibonl(GPIB_BD%, 0)           'remove the device.
    End
End Sub

Private Sub cmdRead_Click()
     txtError.Visible = False
     txtInputMsg.Text = ""
     Call ibrd(GPIB_BD%, Inbuf)
     txtInputMsg.Text = Inbuf
     txtInputMsg.Text = RTrim$(txtInputMsg.Text)
     txtInputMsg.Text = txtInputMsg.Text + NL + Str$(ibcntl) + " bytes received"
     If ckAutoSend.value = 1 Then
        Call cmdSend_Click
    End If
End Sub

Private Sub cmdSend_Click()
    txtError.Visible = False
    Outmsg$ = txtRespMsg.Text
    L = InStr(Outmsg$, Chr$(10))
    If L > 1 Then                                          'if linefeed found
        Outmsg$ = Left$(Outmsg$, L - 1)         'reduce to original string
    End If
    If ckCR.value = 1 Then
        Outmsg$ = Outmsg$ + Chr$(13)
    End If
    If ckLF.value = 1 Then
        Outmsg$ = Outmsg$ + Chr$(10)
    End If
    Call ibwrt(GPIB_BD%, Outmsg$)
    txtRespMsg.Text = txtRespMsg.Text + NL + Str$(ibcntl) + " bytes sent"
End Sub

Private Sub cmdSet_Click()                      'sets board GPIB address from 1 to 30
 NewAddr% = Val(txtAddr.Text)
    If NewAddr% <> Curaddr% Then
        If (NewAddr% >= 1) And (NewAddr% <= 30) Then
            pad% = Val(txtAddr.Text)
            sad% = 0
            nisad% = 0
            dev% = pad%
             Call ibpad(GPIB_BD%, NewAddr%)
             Curaddr% = NewAddr%
        Else
            Beep
            txtResults.Text = "Device Address outside of 1 to 30 range, please reenter"
        End If
        Device = Val(txtAddr.Text)                                   'Device%=ppss format
        txtError.Text = "Board GPIB Address => " + Str$(Device)
    Else
        Beep
        txtError.Visible = True
        txtError.Text = "New Device address same as current address,  please reenter"
    End If
    
    
End Sub

Private Sub Form_Load()
    NL = Chr(13) + Chr(10)
    SPACE80S = Space$(100)                           '100 spaces
    Rev$ = "Revised 07-24-2002"
    txtRev.Text = Rev$
    txtError.Text = ""                                      'clear label and text box
    txtError.Visible = False
    txtInputMsg.Text = ""
    OutFlag = 0
    Buf_length = 1000
    BD% = 0                                                     'define initial values
    dev% = 4
    bddev% = 0
    addr% = 4
    Device = 4
    GPIB_Intfc = "GPIB0"
    txtAddr.Text = "4"
    cmdExit.Enabled = True
    vtmo = T3s                                              'defaut to 3 second timeout
    
    ckCR.value = 0
    ckLF.value = 1
    ckAutoSend.value = 0
    txtError.Enabled = False
    ErrFlag = 0
    
    FirstTimeFlg = 0                                            'GPIB card initialization
    Call ibfind(GPIB_Intfc, GPIB_BD%)                            'get board handle
    If (ibsta% And EERR) Then                                     'set GPIB address
        Call gpiberr("ibfind error")
        txtError.Text = RetMsg$
        txtError.Visible = True
        GoTo Formexit
    End If
    
    Call ibrsc(GPIB_BD%, 0)                                          'make a non controller
    If (ibsta% And EERR) Then                                     'set GPIB address
        Call gpiberr("ibrsc error")
        txtError.Text = RetMsg$
        txtError.Visible = True
        GoTo Formexit
    End If
    
    Curaddr% = Val(txtAddr.Text)
    Call ibpad(GPIB_BD%, Curaddr%)
    If (ibsta% And EERR) Then                                     'set GPIB address
        Call gpiberr("ibpad error")
        txtError.Text = RetMsg$
        txtError.Visible = True
        GoTo Formexit
    End If
    
    cmdSet.Enabled = True
    cmdSend.Enabled = True
    cmdRead.Enabled = True
    FirstTimeFlg = 1
Formexit:
End Sub

